unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Cut1: TMenuItem;
    Delete1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Exit1: TMenuItem;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
    HookHandle: HHOOK = 0;
const
    FORM_ALPHA = 255;
    MENU_ALPHA = 220;

//-----------------------------------------------------------------------------
//  tbN
function HookCallWndProc(nCode: Integer; wParam: WPARAM; pEvnt: PEventMsg): LRESULT; stdcall;
var
    cwps: TCWPStruct;
    szClass: array[0..127] of Char;
begin
    //  Kǂ
    if (nCode = HC_ACTION) then
    begin
        //  gɂ̂ŃLXg
        cwps := PCWPStruct(pEvnt)^;
        //  쐬̃^C~O
        if (cwps.message = WM_CREATE) then
        begin
            //  쐬EBhẼNX擾
            FillChar(szClass, SizeOf(szClass), 0);
            GetClassName(cwps.hwnd, szClass, 127);
            //  R_CAO(j[_CAOƓNX)Ȃ
            if (szClass = '#32768') then
            begin
                //  ̃X^CɓʂX^Ct
                SetWindowLong(cwps.hwnd, GWL_EXSTYLE,
                              GetWindowLong(cwps.hwnd, GWL_EXSTYLE) or WS_EX_LAYERED);
                //  xݒ肷
                SetLayeredWindowAttributes(cwps.hwnd, 0, MENU_ALPHA, LWA_ALPHA);
            end;
        end;
    end;
    //  ƂĂlɔC
    Result := CallNextHookEx(WH_CALLWNDPROC, nCode, wParam, Longint(pEvnt));
end;

//-----------------------------------------------------------------------------
//  tbN
procedure TForm1.FormCreate(Sender: TObject);
begin
    Self.AlphaBlendValue := FORM_ALPHA;
    HookHandle := SetWindowsHookEx(WH_CALLWNDPROC, @HookCallWndProc, 0,
                                    GetWindowThreadProcessId(Handle));
end;

//-----------------------------------------------------------------------------
//  tbN߂
procedure TForm1.FormDestroy(Sender: TObject);
begin
    if (HookHandle <> 0) then UnhookWindowsHookEx(HookHandle);
    HookHandle := 0;
end;

end.

